library xtoolspackage;

import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

extension SortBy on List {
  sortBy(List<String> keys) {
    sort((a, b) {
      for (int k = 0; k < keys.length; k++) {
        String key = keys[k];
        int comparison = Comparable.compare((a[key] ?? ""), (b[key] ?? ""));
        if (comparison != 0) {
          return comparison;
        }
      }
      return 0;
    });
  }
}

class XUtils {
  ///Data minore  DateTime(1900, 1, 1);
  static DateTime dateMinForNull = DateTime(1900, 1, 1);
  static String dateToString(DateTime dt, {String format = ""}) {
    if (dt.compareTo(dateMinForNull) <= 0) {
      return "<no date>";
    } else {
      return DateFormat(format != "" ? "dd/MM/yyyy" : format).format(dt);
    }
  }

  static String dateToStringWithTime(DateTime dt, {String format = ""}) {
    if (dt.compareTo(dateMinForNull) <= 0) {
      return "";
    } else {
      return DateFormat(format != "" ? "dd/MM/yyyy HH:mm" : format + " HH:mm").format(dt);
    }
  }

  static String xToCurrency(BuildContext context, double value) {
    return NumberFormat.simpleCurrency(locale: Localizations.localeOf(context).toString()).format(value);
  }

  static String? validatorBL(dynamic value) {
    if (value == null) return "Compila il campo";

    if (value is DateTime) {
      {
        return null;
      }
    } else if (value.isEmpty) {
      return "Compila il campo";
    }
  }

  static bool? isDataUguale(DateTime dttoCheck, {DateTime? dtRef}) {
    dtRef ??= DateTime.now();
    var r = dttoCheck.year == dtRef.year && dttoCheck.month == dtRef.month && dttoCheck.day == dtRef.day;
    return r;
  }

  static bool isInDays(DateTime dt, int daysBefToday, int daysAftToday) {
    if (dt == DateTime(1900, 1, 1)) {
      return false;
    } else {
      var todayNow = DateTime.now(); //DateTime(2021, 7, 3);
      var todayDay = DateTime(todayNow.year, todayNow.month, todayNow.day);
      var limitSX = dt.compareTo(todayDay.add(Duration(days: daysBefToday))) >= 0; // va bene perché inizia da 00:00
      var limitDX = dt.compareTo(todayDay.add(Duration(days: daysAftToday + 1))) < 0;
      return limitSX & limitDX;
    }
  }

  static String isInDaysLabel(int daysBefToday, int daysAftToday, [String? label, String? format]) {
    var todayEnd = DateTime.now();
    var today = DateTime(todayEnd.year, todayEnd.month, todayEnd.day);
    var limitDX = today.add(Duration(days: daysAftToday));
    var limitSX = today.add(Duration(days: daysBefToday));
    //se c'è la label e i DX e SX sono = non metto le date
    var r = (label ?? "");
    if (label == null) {
      if (limitSX == limitDX) {
        r += dateToString(limitSX, format: format ?? "");
      } else {
        r += dateToString(limitSX, format: format ?? "") + "\n>>\n" + dateToString(limitDX, format: format ?? "");
      }
    } else {
      if (limitSX != limitDX) {
        r += "\n" + dateToString(limitSX, format: format ?? "") + "\n>>\n" + dateToString(limitDX, format: format ?? "");
      }
    }
    return r;
  }
}
